Description

One of the many projects | had for my pi was installing ZFS. While Raspbian is a a good distro for beginners, | require a bit more
control and up to date packages than Raspbian can provide, so | use Arch Linux. This is a guide on how | compiled support for ZFS
on my Raspberry Pi Model B+.

UPDATE: This guide has been tested and works on Arch Linux as of 02/21/15.

NOTE: | have found that installing the zfs-dkms package from the AUR is much easier than trying to roll a custom kernel just for ZFS.

Prepare The System

e Update the system:
pacman —-Syu
e |nstall base-devel, cmake, and linux-headers packages

pacman —-S base-devel cmake linux-headers

Format the USB drives
This guide is using USB drives for its data drives. Yes, | know this will eventually cause a huge bottleneck in 1/0 performance.

e Format /dev/sda:

fdisk /dev/sda

o And type the following to format the USB drive as a Solaris root partition:

Enter]
Enter]

S Wt —— = B Q
\e)

e Format /dev/sdb:

fdisk /dev/sdb
o And type the following to format the USB drive as a Solaris root partition:

Enter]
Enter]

S Wt —— = 5 Q
o)

Install yaourt
Yaourt isn't necessary, but makes managing AUR packages a lot easier.

e |nstall yaourt

Install ZFS DKMS from the AUR

¢ |nstall zfs-dkms:
yvaourt zfs-dkms
e NOTE: Edit the PKGBUILD for zfs-dkms, spl-dkms, and zfs-utils
o And modify the arch parameter to match the following; adding "armv6h" and "armv6l":
arch=("1686" "x86_64" "armvoh" "armvol")

e |nstall zfs-utils:

yaourt zfs-utils

o Force install the zfs-utils package (probably a bad idea, but the only way | could get it to install properly):

pacman -U —--force /tmp/yaourt-tmp-username/zfs-utils-0.6.3-1.2-armvé6h.pkg.tar.xz

o Replace username with the user that built the zfs-utils package
o Replace the version with the current version being installed

o |nstall the zfs kernel module:

depmod -a
modprobe zfs

o Check that the zfs modules were loaded:

1smod

o Example output:

zfs 1229845 0

zunicode 322454 1 zfs

zavl 5993 1 zfs

zCcommon 43765 1 zfs

znvpair 80689 2 zfs, zcommon
spl 165409 5 zfs,zavl,zunicode, zcommon, znvpair

Setting Up The Pools

This guide will be setting up a mirror of 2 USB drives, both will shown as /dev/sda and /dev/sdb, respectively.

Create a storage pool
® Get the id's of the drives to add to the zpool. The zfs on Linux developers recommend using device ids when creating ZFS
storage pools of less than 10 devices. To find the id's, simply:
1s -lah /dev/disk/by-id/
o Example output:
lrwxrwxrwx 1 root root 9 Aug 12 16:26 usb-SanDisk_Cruzer_20015001801AE2D0432E-0:0-partl -
> ../../sda

lrwxrwxrwx 1 root root 9 Aug 12 16:26 usb-SanDisk_Cruzer_20022213091FE2A0CC42-0:0-partl -
> ../../sdb

¢ Create the mirrored ZFS pool:

zpool create —-f -m /mnt/usbpool usbpool mirror /dev/disk/by-id/usb-SanDisk_Cruzer_20015001801A
E2D0432E-0\:0-partl /dev/disk/by-id/usb-SanDisk_Cruzer_20022213091FE2A0CC42-0\:0-partl

NOTE: Make sure the path to the partition is used and not the path for the disk itself, or else an error will occur.

e Check the zpool status:

zpool status
o Example output:
pool: usbpool

state: ONLINE
scan: none requested

config:
NAME STATE READ WRITE CKSUM
usbpool ONLINE 0 0 0
mirror-0 ONLINE

0 0 0
usb-SanDisk_Cruzer_20015001801AE2D0432E-0:0-partl ONLINE 0 0 0
usb-SanDisk_Cruzer_20022213091FE2A0CC42-0:0-partl ONLINE 0 0 0
errors: No known data errors
e Create a mountpoint:
zfs create usbpool/home -o mountpoint=/home

e Check the mount point status:

zfs list usbpool/home
o Example output:

NAME USED AVAIL REFER MOUNTPOINT
usbpool/home 30K 58.6G 30K /home

e Automatically mount the zfs pool:
mkdir -p /etc/zfs
zpool set cachefile=/etc/zfs/zpool.cache usbpool

o Enable the service so it is automatically started at boot time:

systemctl enable zfs.target

o To manually start the daemon:

systemctl start zfs.target

Kernel Upgrades

| found that after upgrading the kernel will not automatically rebuild the ZFS DKMS module, this is to be expected. Rather than
reinstalling from the AUR, the DKMS modules just need to be built again.
e Upgrade the kernel:
pacman —-Syu

e And reboot for the new kernel to take effect:

reboot

Rebuild SPL DKMS

® Rebuild SPL DKMS module:
dkms build spl/0.6.3
e Install SPL DKMS module:

dkms install spl/0.6.3

Rebuild ZFS DKMS

e Rebuild ZFS DKMS module:
dkms build zfs/0.6.3

e Install ZFS DKMS module:
dkms install zfs/0.6.3

o |nstall the zfs kernel module:

depmod -a
modprobe zfs

e Check that the zfs modules were loaded:

1lsmod

o Example output:

zfs 1229845 0

zunicode 322454 1 zfs

zavl 5993 1 zfs

zcommon 43765 1 zfs

znvpair 80689 2 zfs, zcommon

spl 165409 5 zfs,zavl,zunicode, zcommon, znvpair

Tips
Lower ARC size

e Edit the cmdline.txt:

nano /boot/cmdline.txt

o And add zfs.zfs_arc_max=64000000 as a kernel parameter to set the ARC to 64MB:

selinux=0 plymouth.enable=0 smsc95xx.turbo_mode=N dwc_otg.lpm_enable=0 console=ttyAMAO, 115
200 kgdboc=ttyAMAO,115200 console=ttyl root=/dev/mmcblkOp2 rootfstype=ext4d zfs.zfs_arc_max
=64000000 elevator=noop rootwait

Lower kmem size

e Edit the cmdline.txt:

nano /boot/cmdline.txt

o And add vm.kmem_size="256M" vm.kmem_size_max="256M" as a kernel parameter to set the kmem to 256 MB:

selinux=0 plymouth.enable=0 smsc95xx.turbo_mode=N dwc_otg.lpm_enable=0 console=ttyAMAO,115
200 kgdboc=ttyAMAO,115200 console=ttyl root=/dev/mmcblkOp2 rootfstype=ext4d zfs.zfs_arc_max
=64000000 vm.kmem_size="256M" vm.kmem_size_max="256M" elevator=noop rootwait

Lower vdev cache size

o Edit the cmdline.txt:

nano /boot/cmdline.txt

o And add zfs.vdev.cache.size="4M" as a kernel parameter to set the vdev cache size to 4MB:
selinux=0 plymouth.enable=0 smsc95xx.turbo_mode=N dwc_otg.lpm_enable=0 console=ttyAMAO,115
200 kgdboc=ttyAMAO,115200 console=ttyl root=/dev/mmcblkOp2 rootfstype=ext4d zfs.zfs_arc_max
=64000000 vm.kmem_size="256M" vm.kmem_size_max="256M" zfs.vdev.cache.size="4M" elevator=no
op rootwait

Resources

e https://wiki.archlinux.org/index.php/ZFS
¢ https://aur.archlinux.org/packages/zfs-dkms/
¢ https://aur.archlinux.org/packages/zfs-utils/

History

#1 - 01/02/2015 02:23 PM - Daniel Curtis
- Description updated
- % Done changed from 0 to 20

#2 - 01/03/2015 12:11 PM - Daniel Curtis

- Description updated

#3 - 01/20/2015 10:30 AM - Daniel Curtis

- Description updated

#4 - 02/20/2015 06:33 PM - Daniel Curtis

- Description updated

#5 - 02/20/2015 08:55 PM - Daniel Curtis

- Description updated

#6 - 02/20/2015 10:49 PM - Daniel Curtis
- Description updated
- Status changed from New to In Progress

- % Done changed from 20 to 40

#7 - 02/20/2015 11:52 PM - Daniel Curtis
- Description updated

#8 - 02/21/2015 12:00 AM - Daniel Curtis
- Description updated

#9 - 02/21/2015 12:01 AM - Daniel Curtis
- Description updated

#10 - 02/21/2015 07:11 AM - Daniel Curtis
- Description updated

#11 - 02/21/2015 07:19 AM - Daniel Curtis
- Description updated

- % Done changed from 40 to 60

#12 - 02/21/2015 07:32 AM - Daniel Curtis

- Description updated

#13 - 02/21/2015 07:33 AM - Daniel Curtis
https://aur.archlinux.org/packages/zfs-dkms/
https://aur.archlinux.org/packages/zfs-utils/

- Subject changed from Compiling ZFS into Arch Linux on a Raspberry Pi to Installing ZFS for Arch Linux on a Raspberry Pi

#14 - 02/21/2015 07:36 AM - Daniel Curtis

- Description updated

#15 - 02/21/2015 10:42 AM - Daniel Curtis

- Description updated

#16 - 02/21/2015 10:43 AM - Daniel Curtis

- Description updated

#17 - 02/21/2015 11:29 AM - Daniel Curtis
- Description updated
- Status changed from In Progress to Resolved

- % Done changed from 60 to 80

#18 - 02/21/2015 11:36 AM - Daniel Curtis

- Description updated

#19 - 02/21/2015 11:36 AM - Daniel Curtis
- Description updated
- % Done changed from 80 to 100

#20 - 02/22/2015 05:21 PM - Daniel Curtis
- Category set to Network Attached Storage
- Status changed from Resolved to Closed

- Target version set to Arch Linux

#21 - 02/27/2015 09:30 PM - Daniel Curtis
- Description updated

#22 - 03/03/2015 12:27 PM - Daniel Curtis

- Description updated

#23 - 03/03/2015 12:30 PM - Daniel Curtis
- Description updated

#24 - 03/06/2015 10:10 AM - Daniel Curtis
- Description updated

#25 - 03/06/2015 10:34 AM - Daniel Curtis
- Description updated

#26 - 07/15/2016 07:39 PM - Daniel Curtis
- Description updated
